      subroutine bathy(bb)
c
c  Sets up bathymetry tables given the 2XN matrix bb
c
c  Brian Dushaw
c  Applied Physics Laboratory 
c  University of Washington
c  Seattle, WA 98105
c  (206) 543-1300
c  dushaw@apl.washington.edu
c
c  EIGENRAY Version 3.4
c  September-December 1998
c  Last updated November 2012
c
      implicit double precision (a-h,o-z)
      include 'nbath.h'
      include 'bathy.h'
      double precision bb(2,MBATH)
c
c the value of numbot is in the common block defined in bathy.h
c numbot is initiated in the eig subroutine.
      do i=1,numbot
        btab(1,i)=bb(1,i)
        btab(2,i)=bb(2,i)
      enddo
c
c fill in the rest of the bathymetry table

      do i=1,numbot-1
c btab(3,:) is the slope m.
        btab(3,i)=
     *(btab(2,i) - btab(2,i+1))/( btab(1,i) - btab(1,i+1))
c btab(4,i) is the intercept b.
        btab(4,i)=btab(2,i) - btab(1,i)*btab(3,i)
      enddo
      
c  add a few more values for safety...
      btab(3,numbot)=btab(3,numbot-1)
      btab(4,numbot)=btab(4,numbot-1)
      btab(3,numbot+1)=btab(3,numbot-1)
      btab(4,numbot+1)=btab(4,numbot-1)

      return
      end
